Tests for the ntuple production framework.

## Running tests
Use pytest. Additional dependencies are:

```bash
pip install pytest uproot awkward
```

To run the tests, simply run `pytest` in this directory or `pytest test` from the root of this repository.

## Writing tests
Name the test-function with `test_` at the start and put it in a file that also starts with `test_`.

For convenience, there's a fixture called `events` defined in `fixtures.py` that returns the events of an example output ntuple.
Use it as an argument to your test function to use it:

```python
def test_mytest(events):
    observable = calculateobs(events.lep_pt)
    assert observable ...
```
